/*
  Example of very simple template metaprogram
*/

#include <iostream>
#include <fstream>
#include <cmath>

/*
  Define the class factorial.
  This class is empty and has a static integer value.
  Static variables are "common" to all the instance of the 
  classes.
 */
template <int N>
class factorial {
public:
  /*
    Define the static value with the following recurrence.
    In this way compiler must instance classes 
    
    factorial<N-1>
    factorial<N-2>
    ....
  */
  static int const value = N*factorial<N-1>::value ;
  /* old compiler must use this trick insted of static int const value:
  enum { value = N*factorial<N-1>::value } ;
  */
} ;

/*
  Define the s[ecialization of class factorial for N=0.
  This close the recursion when a class factorial<N> is instanced.
 */
template <>
class factorial<0> {
public:
  static int const value = 1 ;
  /* old compiler must use this trick insted of static int const value:
  enum { value = 1 } ;
  */
} ;


int
main() {
  std::cout << "1!  = " << factorial<1>::value  << "\n" ;
  std::cout << "2!  = " << factorial<2>::value  << "\n" ;
  std::cout << "5!  = " << factorial<5>::value  << "\n" ;
  std::cout << "10! = " << factorial<10>::value << "\n" ;
  return 0 ;
}
